import '../enums/fees.dart';
import '../enums/types.dart';

class FeeConfig {
  static final Map<int, int> _fees = {
    Types.transfer: Fees.transfer,
    Types.secondSignature: Fees.secondSignature,
    Types.delegateRegistration: Fees.delegateRegistration,
    Types.vote: Fees.vote,
    Types.multiSignature: Fees.multiSignature,
    Types.ipfs: Fees.ipfs,
    Types.timelockTransfer: Fees.timelockTransfer,
    Types.multiPayment: Fees.multiPayment,
    Types.delegateResignation: Fees.delegateResignation
  };

  static int get(int type) {
    return _fees[type];
  }

  static void set(int type, int fee) {
    _fees[type] = fee;
  }
}