import 'dart:typed_data';
import 'package:convert/convert.dart';
import 'package:pointycastle/ecc/api.dart' show ECPublicKey, ECPoint;

import 'private_key.dart';

class PublicKey {
  ECPublicKey publicKey;

  PublicKey(ECPublicKey publicKey) {
    this.publicKey = publicKey;
  }

  PublicKey.fromPoint(ECPoint point) {
    this.publicKey = new ECPublicKey(point, PrivateKey.domain);
  }

  PublicKey.fromPassphrase(String passphrase) {
    this.publicKey = PrivateKey.fromPassphrase(passphrase).getPublicKey();
  }

  factory PublicKey.fromBuffer(Uint8List buffer) {
    ECPoint point = PrivateKey.domain.curve.decodePoint(buffer);
    return PublicKey.fromPoint(point);
  }

  Uint8List toBytes() {
    return publicKey.Q.getEncoded(true);
  }

  String toHex() {
    return hex.encode(this.toBytes());
  }
}
