import 'dart:convert';
import 'dart:typed_data';
import 'package:crypto/crypto.dart';
import 'package:bs58check/bs58check.dart' as bs58check;

import '../configuration/network.dart';

class Wif {
  Uint8List bytes;

  Wif.fromPassphrase(String passphrase, [int wifVersion]) {
    wifVersion ??= NetworkConfig.get().wif();

    Digest seed = sha256.convert(utf8.encode(passphrase));
    List<int> bytes = new List();

    bytes.add(wifVersion);
    bytes.addAll(seed.bytes);
    bytes.add(0x01);
    
    this.bytes = Uint8List.fromList(bytes);
  }

  String toString() {
    return bs58check.encode(this.bytes);
  }
}