import '../../fixture_loader.dart' as fixture;

import 'package:test/test.dart';
import 'package:ark_dart_crypto/src/identities/address.dart';
import 'package:ark_dart_crypto/src/configuration/network.dart';
import 'package:ark_dart_crypto/src/networks/devnet.dart';

var identity = fixture.load('identity.json');

void main() {
  test('fromPassphrase', () {
    NetworkConfig.set(new Devnet());
    Address address = Address.fromPassphrase(identity['passphrase']);
    expect(address.toString(), equals(identity['data']['address']));
  });

  test('fromPublicKey', () {
    NetworkConfig.set(new Devnet());
    Address address = Address.fromPublicKey(identity['data']['publicKey']);
    expect(address.toString(), equals(identity['data']['address']));
  });

  test('validate', () {
    NetworkConfig.set(new Devnet());
    Address.validate(identity['data']['address']);
  });
}
