 import '../../../fixture_loader.dart' as loader;

import 'package:ark_dart_crypto/src/networks/devnet.dart';
import 'package:ark_dart_crypto/src/configuration/network.dart';
import 'package:ark_dart_crypto/src/transactions/builder.dart';
import 'package:test/test.dart';

var identity = loader.load('identity.json');

void main() {
  test('passphrase', () {
    NetworkConfig.set(new Devnet());
    var fixture = loader.load('transactions/delegate_registration/passphrase.json');
    Builder builder = Builder.delegateRegistration(fixture['data']['asset']['delegate']['username']);
    builder.network(NetworkConfig.get().version());
    builder.fee(fixture['data']['fee']);
    builder.timestamp(fixture['data']['timestamp']);
    builder.sign(identity['passphrase']);
    expect(builder.transaction.signature, fixture['data']['signature']);
    expect(builder.transaction.id, fixture['data']['id']);
  });
}