import '../../../fixture_loader.dart' as loader;

import 'package:ark_dart_crypto/src/transactions/transaction.dart';
import 'package:ark_dart_crypto/src/transactions/deserializer.dart';
import 'package:test/test.dart';

void main() {
  test('passphrase', () {
    var fixture = loader.load('transactions/delegate_registration/passphrase.json');
    Transaction actual = deserialize(fixture['serialized']);
    expect(actual.type, fixture['data']['type']);
    expect(actual.amount, fixture['data']['amount']);
    expect(actual.fee, fixture['data']['fee']);
    expect(actual.timestamp, fixture['data']['timestamp']);
    expect(actual.senderPublicKey, fixture['data']['senderPublicKey']);
    expect(actual.signature, fixture['data']['signature']);
    expect(actual.asset['delegate']['username'], fixture['data']['asset']['delegate']['username']);
    expect(actual.id, fixture['data']['id']);
  });

  test('second passphrase', () {
    var fixture = loader.load('transactions/delegate_registration/second_passphrase.json');
    Transaction actual = deserialize(fixture['serialized']);
    expect(actual.type, fixture['data']['type']);
    expect(actual.amount, fixture['data']['amount']);
    expect(actual.fee, fixture['data']['fee']);
    expect(actual.timestamp, fixture['data']['timestamp']);
    expect(actual.senderPublicKey, fixture['data']['senderPublicKey']);
    expect(actual.signature, fixture['data']['signature']);
    expect(actual.signSignature, fixture['data']['signSignature']);
    expect(actual.asset['delegate']['username'], fixture['data']['asset']['delegate']['username']);
    expect(actual.id, fixture['data']['id']);
  });
}