import '../../../fixture_loader.dart' as loader;

import 'package:ark_dart_crypto/src/transactions/transaction.dart';
import 'package:ark_dart_crypto/src/transactions/deserializer.dart';
import 'package:test/test.dart';

void main() {
  test('passphrase', () {
    var fixture = loader.load('transactions/transfer/passphrase.json');
    Transaction actual = deserialize(fixture['serialized']);
    expect(actual.type, fixture['data']['type']);
    expect(actual.amount, fixture['data']['amount']);
    expect(actual.fee, fixture['data']['fee']);
    expect(actual.recipientId, fixture['data']['recipientId']);
    expect(actual.timestamp, fixture['data']['timestamp']);
    expect(actual.senderPublicKey, fixture['data']['senderPublicKey']);
    expect(actual.signature, fixture['data']['signature']);
    expect(actual.id, fixture['data']['id']);
  });

  test('passphrase with vendorField', () {
    var fixture = loader.load('transactions/transfer/passphrase_with_vendor_field.json');
    Transaction actual = deserialize(fixture['serialized']);
    expect(actual.type, fixture['data']['type']);
    expect(actual.amount, fixture['data']['amount']);
    expect(actual.fee, fixture['data']['fee']);
    expect(actual.recipientId, fixture['data']['recipientId']);
    expect(actual.timestamp, fixture['data']['timestamp']);
    expect(actual.senderPublicKey, fixture['data']['senderPublicKey']);
    expect(actual.vendorField, fixture['data']['vendorField']);
    expect(actual.signature, fixture['data']['signature']);
    expect(actual.id, fixture['data']['id']);
  });

  test('passphrase with vendorFieldHex', () {
    var fixture = loader.load('transactions/transfer/passphrase_with_vendor_field_hex.json');
    Transaction actual = deserialize(fixture['serialized']);
    expect(actual.type, fixture['data']['type']);
    expect(actual.amount, fixture['data']['amount']);
    expect(actual.fee, fixture['data']['fee']);
    expect(actual.recipientId, fixture['data']['recipientId']);
    expect(actual.timestamp, fixture['data']['timestamp']);
    expect(actual.vendorFieldHex, fixture['data']['vendorFieldHex']);
    expect(actual.signature, fixture['data']['signature']);
    expect(actual.id, fixture['data']['id']);
  });

  test('second passphrase', () {
    var fixture = loader.load('transactions/transfer/second_passphrase.json');
    Transaction actual = deserialize(fixture['serialized']);
    expect(actual.type, fixture['data']['type']);
    expect(actual.amount, fixture['data']['amount']);
    expect(actual.fee, fixture['data']['fee']);
    expect(actual.recipientId, fixture['data']['recipientId']);
    expect(actual.timestamp, fixture['data']['timestamp']);
    expect(actual.signature, fixture['data']['signature']);
    expect(actual.signSignature, fixture['data']['signSignature']);
    expect(actual.id, fixture['data']['id']);
  });

  test('second passphrase with vendorField', () {
    var fixture = loader.load('transactions/transfer/second_passphrase_with_vendor_field.json');
    Transaction actual = deserialize(fixture['serialized']);
    expect(actual.type, fixture['data']['type']);
    expect(actual.amount, fixture['data']['amount']);
    expect(actual.fee, fixture['data']['fee']);
    expect(actual.recipientId, fixture['data']['recipientId']);
    expect(actual.timestamp, fixture['data']['timestamp']);
    expect(actual.senderPublicKey, fixture['data']['senderPublicKey']);
    expect(actual.vendorField, fixture['data']['vendorField']);
    expect(actual.signature, fixture['data']['signature']);
    expect(actual.signSignature, fixture['data']['signSignature']);
    expect(actual.id, fixture['data']['id']);
  });

  test('second passphrase with vendorFieldHex', () {
    var fixture = loader.load('transactions/transfer/second_passphrase_with_vendor_field_hex.json');
    Transaction actual = deserialize(fixture['serialized']);
    expect(actual.type, fixture['data']['type']);
    expect(actual.amount, fixture['data']['amount']);
    expect(actual.fee, fixture['data']['fee']);
    expect(actual.recipientId, fixture['data']['recipientId']);
    expect(actual.timestamp, fixture['data']['timestamp']);
    expect(actual.senderPublicKey, fixture['data']['senderPublicKey']);
    expect(actual.vendorFieldHex, fixture['data']['vendorFieldHex']);
    expect(actual.signature, fixture['data']['signature']);
    expect(actual.signSignature, fixture['data']['signSignature']);
    expect(actual.id, fixture['data']['id']);
  });
}