import '../../../fixture_loader.dart' as loader;

import 'package:ark_dart_crypto/src/transactions/transaction.dart';
import 'package:ark_dart_crypto/src/transactions/deserializer.dart';
import 'package:ark_dart_crypto/src/transactions/serializer.dart';
import 'package:test/test.dart';
import 'package:convert/convert.dart';

void main() {
  test('passphrase', () {
    var fixture = loader.load('transactions/transfer/passphrase.json');
    Transaction transaction = deserialize(fixture['serialized']);
    String actual = hex.encode(serialize(transaction));
    expect(actual, fixture['serialized']);
  });

  test('passphrase with vendorField', () {
    var fixture = loader.load('transactions/transfer/passphrase_with_vendor_field.json');
    Transaction transaction = deserialize(fixture['serialized']);
    String actual = hex.encode(serialize(transaction));
    expect(actual, fixture['serialized']);
  });

  test('passphrase with vendorFieldHex', () {
    var fixture = loader.load('transactions/transfer/passphrase_with_vendor_field_hex.json');
    Transaction transaction = deserialize(fixture['serialized']);
    String actual = hex.encode(serialize(transaction));
    expect(actual, fixture['serialized']);
  });

  test('second passphrase', () {
    var fixture = loader.load('transactions/transfer/second_passphrase.json');
    Transaction transaction = deserialize(fixture['serialized']);
    String actual = hex.encode(serialize(transaction));
    expect(actual, fixture['serialized']);
  });

  test('second passphrase with vendorField', () {
    var fixture = loader.load('transactions/transfer/second_passphrase_with_vendor_field.json');
    Transaction transaction = deserialize(fixture['serialized']);
    String actual = hex.encode(serialize(transaction));
    expect(actual, fixture['serialized']);
  });

    test('second passphrase with vendorFieldHex', () {
    var fixture = loader.load('transactions/transfer/second_passphrase_with_vendor_field_hex.json');
    Transaction transaction = deserialize(fixture['serialized']);
    String actual = hex.encode(serialize(transaction));
    expect(actual, fixture['serialized']);
  });
}