import '../../../fixture_loader.dart' as loader;

import 'package:ark_dart_crypto/src/transactions/transaction.dart';
import 'package:ark_dart_crypto/src/transactions/deserializer.dart';
import 'package:test/test.dart';

var identity = loader.load('identity.json');

void main() {
  test('passphrase', () {
    var fixture = loader.load('transactions/delegate_registration/passphrase.json');
    Transaction transaction = deserialize(fixture['serialized']);
    transaction.signature = null;
    transaction.sign(identity['passphrase']);
    expect(transaction.signature, fixture['data']['signature']);
    expect(transaction.id, fixture['data']['id']);
  });

  test('second passphrase', () {
    var fixture = loader.load('transactions/delegate_registration/second_passphrase.json');
    Transaction transaction = deserialize(fixture['serialized']);
    transaction.signature = null;
    transaction.sign(identity['passphrase']);
    expect(transaction.signature, fixture['data']['signature']);
    expect(transaction.id, fixture['data']['id']);
  });
}