import '../../fixture_loader.dart' as fixture;

import 'package:convert/convert.dart';

import 'package:test/test.dart';
import 'package:ark_dart_crypto/src/utils/signature.dart';

var signatures = fixture.load('utils/signatures.json');

void main() {
  test('decode signature to DER', () {
    for (var item in signatures) {
      Signature signature = Signature.decode(hex.decode(item['signature']));
      String der = hex.encode(signature.toDER());
      expect(item['DER'], der);
    }
  });

  test('from DER to signature', () {
    for (var item in signatures) {
      Signature der = Signature.fromDER(hex.decode(item['DER']));
      String signature = hex.encode(der.encode());
      expect(item['signature'], signature);
    }
  });
}